<template>
  <div>
    <div class="row">
      <div class="col-xs-12">
        <p class="add-subscription-title">Период действия</p>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-radio
            v-for="item in period"
            :key="item.value"
            :label="item.title"
            v-model="selectedPeriod"
            :valueInput="item.value"
        />
      </div>
    </div>
    <div
        v-if="selectedPeriod === 'for_period'"
        class="row"
    >
      <ob-date-picker-constructor
        label="Действует от"
        :value="activeFromDate"
        class="col-xs-4"
        :blockDaysBeforeToday="true"
        @input="input($event, 'activeFromDate')"
      />

      <ob-date-picker-constructor
        label="Действует до"
        v-model="subscription.activeToDate"
        class="col-xs-4"
        :blockDaysBeforeToday="true"
        :isValidDate="isActiveToDateValid"
        :sinceTo="[
          {
            from: new Date(1976, 0, 0),
            to: activeFromDate
          }
        ]"
        dateValidationMessage="Дата окончания подписки должна быть позже даты начала"
        :blockTimeDateBefore="activeFromDate"
        @input="input($event, 'activeToDate')"
      />
    </div>
  </div>
</template>

<script>
  import ObRadio from 'common-components/src/obComponents/obRadio';
  import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor';
  import { mapGetters } from 'vuex';
  import moment from 'moment';

  export default {
    name: 'SubscriptionModalPeriod',
    components: {
      ObRadio,
      ObDatePickerConstructor
    },
    props: {
      activeToDate: {
        type: [Date, String]
      },
      activeFromDate: {
        type: [Date, String]
      },
      isActiveToDateValid: {
        type: Boolean,
        default: true
      },
    },
    data() {
      return {
        selectedPeriod: 'indefinitely',
        period: [
          {
            title: 'Бессрочно',
            value: 'indefinitely'
          },
          {
            title: 'На период',
            value: 'for_period'
          }
        ],
        defaultDate: '',
        moment,
      }
    },
    computed: {
      ...mapGetters({
        subscription: 'subscriptions/subscription'
      }),
    },
    watch: {
      selectedPeriod (period) {
        if (period === 'indefinitely') {
          this.clearPeriod();
        }
      }
    },
    mounted () {
      if (this.subscription.activeToDate) {
        this.selectedPeriod = 'for_period'
      }
    },
    methods: {
      clearPeriod() {
        this.$emit('setDate', new Date(), 'activeFromDate')
        this.$emit('setDate', null, 'activeToDate')
      },
      input(event, direction) {
        this.$emit('setDate', event, direction)
      }
    }
  };
</script>